<template>
  <div ref="chart" class="w-full h-full"></div>
</template>

<script setup lang="ts">
import { ref, onMounted, defineProps, watch } from 'vue';
// 引入 echarts 核心模块，核心模块提供了 echarts 使用必须要的接口。
import * as echarts from 'echarts/core';
// 引入柱状图图表，图表后缀都为 Chart
import { BarChart } from 'echarts/charts';
// 引入标题，提示框，直角坐标系，数据集，内置数据转换器组件，组件后缀都为 Component
import {
  TitleComponent,
  TooltipComponent,
  GridComponent,
  DatasetComponent,
  TransformComponent,
} from 'echarts/components';
// 标签自动布局、全局过渡动画等特性
import { LabelLayout, UniversalTransition } from 'echarts/features';
// 引入 Canvas 渲染器，注意引入 CanvasRenderer 或者 SVGRenderer 是必须的一步
import { CanvasRenderer } from 'echarts/renderers';
import type { EChartsOption } from 'echarts';

// 注册必须的组件
echarts.use([
  TitleComponent,
  TooltipComponent,
  GridComponent,
  DatasetComponent,
  TransformComponent,
  BarChart,
  LabelLayout,
  UniversalTransition,
  CanvasRenderer,
]);

const props = defineProps<{
  options: EChartsOption;
}>();

const chart = ref<HTMLDivElement>();
const instance = ref<echarts.ECharts>();

watch(
  () => props.options,
  () => {
    instance.value?.setOption(props.options, true);
  },
);

onMounted(() => {
  instance.value = echarts.init(chart.value);
  instance.value.setOption(props.options);
});
</script>
